## GtkApplicationWindow GtkApplicationWindow — GtkWindow subclass with GtkApplication support |

## Functions

GtkWidget * | gtk_application_window_new ()
void | gtk_application_window_set_show_menubar ()
gboolean | gtk_application_window_get_show_menubar ()
guint | gtk_application_window_get_id ()

## Properties

gboolean | show-menubar | Read / Write / Construct

## Types and Values

struct | GtkApplicationWindow
struct | GtkApplicationWindowClass

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkContainer
                    ╰── GtkBin
                        ╰── GtkWindow
                            ╰── GtkApplicationWindow

## Implemented Interfaces

GtkApplicationWindow implements AtkImplementorIface, GtkBuildable, GActionGroup and GActionMap.

## Includes

    #include <gtk/gtk.h>

## Description

GtkApplicationWindow is a GtkWindow subclass that offers some extra functionality for better integration with GtkApplication features. Notably, it can handle both the application menu as well as the menubar. See `gtk_application_set_app_menu()` and `gtk_application_set_menubar()`.

This class implements the GActionGroup and GActionMap interfaces, to let you add window-specific actions that will be exported by the associated GtkApplication, together with its application-wide actions. Window-specific actions are prefixed with the “win.” prefix and application-wide actions are prefixed with the “app.” prefix. Actions must be addressed with the prefixed name when referring to them from a GMenuModel.

Note that widgets that are placed inside a GtkApplicationWindow can also activate these actions, if they implement the GtkActionable interface.

As with GtkApplication, the GDK lock will be acquired when processing actions arriving from other processes and should therefore be held when activating actions locally (if GDK threads are enabled).

The settings “gtk-shell-shows-app-menu” and “gtk-shell-shows-menubar” tell GTK+ whether the desktop environment is showing the application menu and menubar models outside the application as part of the desktop shell. For instance, on OS X, both menus will be displayed remotely; on Windows neither will be. gnome-shell (starting with version 3.4) will display the application menu, but not the menubar.

If the desktop environment does not display the menubar, then GtkApplicationWindow will automatically show a GtkMenuBar for it. (see the GtkApplication docs for some screenshots of how this looks on different platforms). This behaviour can be overridden with the “show-menubar” property. If the desktop environment does not display the application menu, then it will automatically be included in the menubar. It can also be shown as part of client-side window decorations, e.g. by using `gtk_header_bar_set_show_close_button()`.

#### A GtkApplicationWindow with a menubar

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    app = gtk-application-new">gtk_application_new ();

    builder = gtk-builder-new-from-string">gtk_builder_new_from_string (
        "<interface>"
        "  <menu id='menubar'>"
        "    <submenu label='_Edit'>"
        "      <item label='_Copy' action='win.copy'/>"
        "      <item label='_Paste' action='win.paste'/>"
        "    </submenu>"
        "  </menu>"
        "</interface>",
        -1);

    menubar = G_MENU_MODEL (gtk-builder-get-object">gtk_builder_get_object (builder,
                                                    "menubar"));
    gtk-application-set-menubar">gtk_application_set_menubar (G_APPLICATION (app),
                                 menubar);
    g-object-unref">g_object_unref (builder);

    ...

    window = gtk-application-window-new">gtk_application_window_new (app);

#### Handling fallback yourself

A simple example

The XML format understood by GtkBuilder for GMenuModel consists of a toplevel `<menu>` element, which contains one or more `<item>` elements. Each `<item>` element contains `<attribute>` and `<link>` elements with a mandatory name attribute. `<link>` elements have the same content model as `<menu>`.

Attribute values can be translated using gettext, like other GtkBuilder content. `<attribute>` elements can be marked for translation with a `translatable="yes"` attribute. It is also possible to specify message context and translator comments,using the context and comments attributes. To make use of this, the GtkBuilder must have been given the gettext domain to use.

## Functions

### gtk_application_window_new ()

    GtkWidget *
    gtk_application_window_new (GtkApplication *application);

Creates a new GtkApplicationWindow.

#### Parameters

application | a GtkApplication |

#### Returns

a newly created GtkApplicationWindow

Since 3.4

### gtk_application_window_set_show_menubar ()

    void
    gtk_application_window_set_show_menubar
                                   (GtkApplicationWindow *window,
                                    gboolean show_menubar);

Sets whether the window will display a menubar for the app menu and menubar as needed.

#### Parameters

window | a GtkApplicationWindow |
show_menubar | whether to show a menubar when needed |

Since 3.4

### gtk_application_window_get_show_menubar ()

    gboolean
    gtk_application_window_get_show_menubar
                                   (GtkApplicationWindow *window);

Returns whether the window will display a menubar for the app menu and menubar as needed.

#### Parameters

window | a GtkApplicationWindow |

#### Returns

`TRUE` if `window` will display a menubar when needed

Since 3.4

### gtk_application_window_get_id ()

    guint
    gtk_application_window_get_id (GtkApplicationWindow *window);

Returns the unique ID of the window. If the window has not yet been added to a GtkApplication, returns `0`.

#### Parameters

window | a GtkApplicationWindow |

#### Returns

the unique ID for `window` , or `0` if the window has not yet been added to a GtkApplication

Since 3.6

## Types and Values

### struct GtkApplicationWindow

    struct GtkApplicationWindow;

### struct GtkApplicationWindowClass

    struct GtkApplicationWindowClass {
      GtkWindowClass parent_class;
    };

#### Members

GtkWindowClass `parent_class`; | The parent class. |

## Property Details

### The `“show-menubar”` property

      “show-menubar”             gboolean

If this property is `TRUE`, the window will display a menubar that includes the app menu and menubar, unless these are shown by the desktop shell. See `gtk_application_set_app_menu()` and `gtk_application_set_menubar()`.

If `FALSE`, the window will not display a menubar, regardless of whether the desktop shell is showing the menus or not.

Flags: Read / Write / Construct

Default value: TRUE